function out=Yagi_Antenna_Slave(X)

global scrsz

lambda  = X(1);			% vlnov dlka napjecho napt
a = X(2);		      	% polomr vodie antny
l = X(3); 			      % dlka vodie antny
N = X(4);               %poet element
diff(1)=X(5);           %o kolik element je rameno aktivniho diplu krat oproti ramenu reflektoru
diff(2)=X(6);           %o kolik element je rameno direktoru krat oproti ramenu reflektoru
feed=X(7);              %vstupn element
M=X(8);                 %poet prvk
x(1)=X(9);              %x-ov souadnice reflektoru
x(2)= 0;	      			% x-v souadnice diplu
x(3)=-X(10);            % x-v souadnice 1. direktoru

for o=4:M
   x(o)=x(o-1)-X(11);
end;

mi	= 4*pi*1e-7;			% permeabilita vakua
epsilon = 8.85e-12;			% permitivita vakua

delta	= l/(N+1);			% dlka jednoho elementu antny

k	= 2*pi/lambda;			% vlnov slo vyzaovan vlny
omega	= k*3e+8;			% hlov kmitoet napjecho napt
alfa    = 0.5*delta;		% polovina dlky elementu


            % VPOET G.F. NUMERICKOU INTEGRAC

% vpoet diagonlnch submatic

for m=1:(N+2)				
  z = (m-1)*delta;
  psi(m)   = quadl('r',-alfa,alfa,1e-5,0,z,0,a,k)/(2*alfa);
end

% vpoet ostatnch submatic

y=1;
for o=1:(M-1)
  for p=(o+1):M
    for m=1:(N+2)
      z=(m-1)*delta;
      x_psi(m,y) = quadl('r',-alfa,alfa,1e-5,0,z,x(o)-x(p),a,k)/(2*alfa);
    end;
    y=y+1;
  end;
end;


			% VPOET IMPEDANN MATICE

% vpoet diagonlnch submatic
  
for m=1:N 
  for n=m:N 
    dist  = abs(m-n);
    hlp1  = j*omega*mi*(delta^2)*psi(1+dist);
    hlp2  = (2*psi(1+dist) - psi(1+abs(dist-1)) - psi(1+abs(dist+1)))/(j*omega*epsilon);
    Zmax(m,n)=hlp1+hlp2;
    Zmax(n,m)=Zmax(m,n);
 end;
end;
Z(1:N,1:N)=Zmax(1:N,1:N);
Z((N+1):(2*N-2*diff(1)),(N+1):(2*N-2*diff(1)))=Zmax(1:(N-2*diff(1)),1:(N-2*diff(1)));
count=2*N-2*diff(1);
for o=3:M
   Z((count+1):(count+N-2*diff(2)),(count+1):(count+N-2*diff(2)))=Zmax(1:(N-2*diff(2)),1:(N-2*diff(2)));
   count=count+N-2*diff(2);
end;

% vpoet naddiagonlnch submatic

%vzjemn impedance reflektoru a aktivnho diplu 

y=1;
for m=1:N
   for n=(1+diff(1)):(N-diff(1))
      dist=abs(m-n);
      hlp1=j*omega*mi*(delta^2)*x_psi(1+dist,y);
      hlp2=(2*x_psi(1+dist,y)-x_psi(1+abs(dist-1),y)-x_psi(1+abs(dist+1),y))/(j*omega*epsilon);
      Z(m,(N+n-diff(1)))=hlp1+hlp2;
      Z((N+n-diff(1)),m)=hlp1+hlp2;
   end;
end;

%vzjemn impedance reflektoru a direktor

y=2;
for o=3:M
   for m=1:N
      for n=(1+diff(2)):(N-diff(2))
         dist=abs(m-n);
         hlp1=j*omega*mi*(delta^2)*x_psi(1+dist,y);
         hlp2=(2*x_psi(1+dist,y)-x_psi(1+abs(dist-1),y)-x_psi(1+abs(dist+1),y))/(j*omega*epsilon);
         Z(m,(2*N+(o-3)*(N-2*diff(2))+n-2*diff(1)-diff(2)))=hlp1+hlp2;
         Z((2*N+(o-3)*(N-2*diff(2))+n-2*diff(1)-diff(2)),m)=hlp1+hlp2;
      end;
   end;
   y=y+1;
end;

%vzjemn impedance aktivnho diplu a direktor

for o=3:M
   for m=1:(N-2*diff(1))
      for n=(1+abs(diff(2)-diff(1))):(N-2*diff(2)+abs(diff(2)-diff(1)))
         dist=abs(m-n);
         hlp1=j*omega*mi*(delta^2)*x_psi(1+dist,y);
         hlp2=(2*x_psi(1+dist,y)-x_psi(1+abs(dist-1),y)-x_psi(1+abs(dist+1),y))/(j*omega*epsilon);
         Z((N+m),(2*N+(o-3)*(N-2*diff(2))-2*diff(1)+n-abs(diff(2)-diff(1))))=hlp1+hlp2;
         Z((2*N+(o-3)*(N-2*diff(2))-2*diff(1)+n-abs(diff(2)-diff(1))),(N+m))=hlp1+hlp2;
      end;
   end;
   y=y+1;
end;

%vzjemn impedance vsech direktor navzjem

for o=3:(M-1)
  for p=(o+1):M
    for m=1:(N-2*diff(2))
      for n=1:(N-2*diff(2))
         dist=abs(m-n);
         hlp1=j*omega*mi*(delta^2)*x_psi(1+dist,y);
         hlp2=(2*x_psi(1+dist,y)-x_psi(1+abs(dist-1),y)-x_psi(1+abs(dist+1),y))/(j*omega*epsilon);
         Z(2*N-2*diff(1)+m+(o-3)*(N-2*diff(2)),3*N-2*diff(1)-2*diff(2)+n+(p-4)*(N-2*diff(2)))=hlp1+hlp2;
         Z(3*N-2*diff(1)-2*diff(2)+n+(p-4)*(N-2*diff(2)),2*N-2*diff(1)+m+(o-3)*(N-2*diff(2)))=hlp1+hlp2;
      end;
    end;
    y=y+1;
  end;
end;

Y  =  inv( Z);  			% vpoet inverzn (admitann) matice

for m=1:(N-2*diff(1))				% vpoet proudov distribuce na diplu
  I(m)=Y(m+N,feed);
  n(m)=m;
end

figure('Name','Yagiho antna 1.0 ', ...
   'NumberTitle','off', ...
   'ToolBar','none', ...
   'MenuBar','none', ...
   'Position',[scrsz(3)/2-300 scrsz(4)/2-300 600 600], ...
   'Resize','off');

modul = abs(I)*1e+3;
phase = angle(I)*180/pi;

subplot(2,1,1);				% zobrazen 
plot(n,modul,'b-');
ylabel('Module of the current in dipole [mA]  ');
xlabel('Segments');
subplot(2,1,2);
plot(n,phase,'b-');
ylabel('Phase of the current in dipole [] ');
xlabel('Segments');

for m=1:N				% vpoet proudov distribuce na reflektoru
  I(m)=Y(m,feed);
  n(m)=m;
end

modul = abs(I)*1e+3;
phase = angle(I)*180/pi;

pause;
subplot(2,1,1);				% zobrazen 
plot(n,modul,'b-');
ylabel('Module of the current in reflector [mA] ');
xlabel('Segments');
subplot(2,1,2);
plot(n,phase,'b-');
ylabel('Phase of the current in reflector []  ');
xlabel('Segments');

for o=3:M

  for m=1:(N-2*diff(2))				% vpoet proudov distribuce na direktorech
     Id(m)=Y(2*N-2*diff(1)+m+(o-3)*(N-2*diff(2)),feed);
     u(m)=m;
  end

  moduld = abs(Id)*1e+3;
  phased = angle(Id)*180/pi;

  pause;
  subplot(2,1,1);				% zobrazen 
  plot(u,moduld,'b-');
  ylabel(['Module of the current in ',int2str(o-2),'. -th director [mA]']);
  xlabel('Segments');
  subplot(2,1,2);
  plot(u,phased,'b-');
  ylabel(['Phase of the current in ',int2str(o-2),'. -th director []']);
  xlabel('Segments');
end;

pause;
I = Y(:,feed);
D=N;
E=0;
c=0;
for m=1:361
  beta(m)=(m-1)*pi/180;
  hlp1=delta*cos(beta(m));
  for o=1:M
    y=x(1)-x(o);
    hlp2=y*sin(beta(m));
    if o==2
      D=N-2*diff(1);
      E=N;
      c=diff(1);
    elseif o==3
      D=N-2*diff(2);
      E=2*N-2*diff(1);
      c=diff(2);
    elseif o>3
      E=E+N-2*diff(2);
      c=diff(2);
    end; 
    for n=1:D
      R(n+E)=hlp2+c*hlp1;
      c=c+1;
    end;
  end;
  F(m)=exp(-j*k*R)*I;
  F(m)=abs(sin(beta(m))*F(m));
end

y=max(F);
for m=1:361
   F(m)=F(m)/y;
end;

subplot(1,1,1);
plot(beta*180/pi,F,'b-');
xlabel('hel beta []');
title('Directivity pattern - cartesiean coordinates ');

pause;
polar(beta,F,'b-');
xlabel('hel beta []');
ylabel('F/Fmax');
title('Directivity pattern - polar coordinates ');

pom = 1/Y(feed,feed);
handle=findobj('Tag','figure');
set(handle,'Name',['Yagiho antenna 1.0 (Input impedance = ',num2str(pom),' Ohm)']);





